
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:zxing_lib/client.dart';

import '../models/utils.dart';
import '../widgets/list_tile_group.dart';
import '../widgets/result_type_picker.dart';
import '../widgets/cupertino_list_tile.dart';

class IndexPage extends StatefulWidget {
  @override
  State<StatefulWidget> createState() => _IndexPageState();
}

class _IndexPageState extends State<IndexPage> {
  ParsedResultType result = ParsedResultType.TEXT;

  setResult() async {
    ParsedResultType? newResult = await showCupertinoDialog<ParsedResultType>(
      context: context,
      barrierDismissible: true,
      builder: (context) {
        ParsedResultType type = result;
        return Align(
          alignment: Alignment.center,
          child: Padding(
            padding: EdgeInsets.symmetric(vertical: 200, horizontal: 50),
            child: CupertinoPopupSurface(
              child: Column(
                children: [
                  Text('请选择', style: TextStyle(height: 2.4, ),),
                  Expanded(
                    child: Container(
                      color: Colors.white,
                      child: ResultTypePicker(
                        value: result,
                        onChange: (newType) {
                          type = newType;
                        },
                      ),
                    ),
                  ),
                  CupertinoButton(
                    child: Text('确定'),
                    onPressed: () {
                      Navigator.of(context).pop(type);
                    },
                  )
                ],
              ),
            ),
          ),
        );
      },
    );
    if (newResult != null) {
      result = newResult;
    }
  }

  @override
  Widget build(BuildContext context) {
    return CupertinoPageScaffold(
      navigationBar: CupertinoNavigationBar(
        middle: Text('Generator'),
      ),
      backgroundColor: Colors.black12,
      child: SafeArea(
        child:Padding(
          padding: EdgeInsets.only(top: 20),
          child: ListTileGroup(
          children: [
            CupertinoListTile(
              title: Text('内容类型'),
              onTap: () {
                setResult();
              },
              trailing: Text(resultTypeLabel(result)),
            ),
            CupertinoListTile(
              title: Text('内容格式'),
              trailing: Text('默认'),
              isLink: true,
            ),
            CupertinoListTile(
              title: Text('二维码样式'),
              trailing: Text('默认'),
              isLink: true,
            ),
          ],
        ),) ,
      ),
    );
  }
}
