
import 'package:flutter/cupertino.dart';
import 'package:zxing_lib/client.dart';

import '../models/utils.dart';

class ResultTypePicker extends StatefulWidget{
  final ParsedResultType value;
  final void Function(ParsedResultType type)? onChange;

  const ResultTypePicker({Key? key, this.value = ParsedResultType.TEXT, this.onChange}) : super(key: key);

  @override
  State<ResultTypePicker> createState() => _ResultTypePickerState();
}

class _ResultTypePickerState extends State<ResultTypePicker> {
  late FixedExtentScrollController _scrollController;
  @override
  void initState() {
    super.initState();
    _scrollController = FixedExtentScrollController(initialItem: ParsedResultType.values.indexOf(widget.value));
  }

  @override
  Widget build(BuildContext context) {
    return CupertinoPicker(
      itemExtent: 30,
      scrollController: _scrollController,
      onSelectedItemChanged: (idx) {
        if(widget.onChange != null) {
          widget.onChange!(ParsedResultType.values[idx]);
        }
      },
      children: ParsedResultType.values.map<Widget>((e) => Text(resultTypeLabel(e))).toList(),
    );
  }
}